using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Reflection;

namespace DBAccess.EAI
{
    public sealed class DataAccess
    {

        // Look up the DAL implementation we should be using
        private static  string pathPre = "junction" ;
      

        private DataAccess() 
        { 
            
        }

        public static System.Windows.Forms.Form CreateParameterDB()
        {

            try
            {
                string className = pathPre + ClsGlobal.defaultUsedSoftware + ".FrmParameterDB";
                return (System.Windows.Forms.Form)Assembly.Load(pathPre + ClsGlobal.defaultUsedSoftware).CreateInstance(className);
            }
            catch (Exception ex)
            {
                Boundary.EAI.ClsFormInfo.LogError(ex);                
                return null;
            }

        }


        public static ISTKSaveDBInterface CreateSTKSaveDBInterface()
        {

            try
            {
                string className = pathPre + ClsGlobal.defaultUsedSoftware + ".ClsSTKSaveDBControl";
                return (ISTKSaveDBInterface)Assembly.Load(pathPre + ClsGlobal.defaultUsedSoftware).CreateInstance(className);
            }
            catch (Exception ex)
            {
                return null;
            }

        }



    }
}
