using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Boundary.EAI;
using DBAccess.EAI;
using Control.STK;


namespace Boundary.STK
{
    public partial class FrmParameterFile : Form
    {

        private ClsFormProcess2 pClsFormProcess;
        //private ClsSystemParameter pcontrol;
        public string OldSkinName;
        public FrmParameterFile()
        {
            InitializeComponent();
        }

        public ClsFormProcess2 getFormProcess()
        {
            if (pClsFormProcess == null)
                pClsFormProcess = new ClsFormProcess2(this, true);
            return pClsFormProcess;
        }

        private void FrmParameterFile_Load(object sender, EventArgs e)
        {

            if (pClsFormProcess == null)
                pClsFormProcess = new ClsFormProcess2(this, true);

            tabControl1.SelectedIndex = 0;
            cmbdefaultSeparateChar.SelectedIndex = 0;
            button1_Click(null, null);
           
        }


       
        private void button4_Click(object sender, EventArgs e)
        {
            //ADODB._Connection ADOConn;
            //MSDASC.DataLinks dbDialog = new MSDASC.DataLinks();
            //ADOConn = (ADODB._Connection)dbDialog.PromptNew();
            //if (ADOConn != null)
            //{
            //    ClsDataConnect.SaveConnection(ADOConn.ConnectionString);
            //    ClsGlobal.objDataConnect.XMLDataConnect();
            //}

            ClsParameterFileFormatControl.sisDeleteExport = ckbisDeleteExport.Checked;
            ClsParameterFileFormatControl.sisConfirminDelete = ckbisConfirminDelete.Checked;

            ClsParameterFileFormatControl.sisAllowEmpty = ckbisAllowEmpty.Checked;


            if (rdbMSExcel.Checked)
                ClsParameterFileFormatControl.ssFileType = "MSExcel";
            if (rdbCSV.Checked)
                ClsParameterFileFormatControl.ssFileType = "CSV";
            if (rdbText.Checked)
                ClsParameterFileFormatControl.ssFileType = "TXT";
            if (rdbXML.Checked)
                ClsParameterFileFormatControl.ssFileType = "XML";

            ClsParameterFileFormatControl.sidefaultSeparateChar = cmbdefaultSeparateChar.SelectedIndex; 

            ListViewItem item;
            int len = ClsParameterFileFormatControl.sscColumnName.Count;
            for (int i = 0; i < len; i++)
            {
                item = lvAvailable.Items[i];
                ClsParameterFileFormatControl.sscColumnSelected[i] = item.Checked ? "1" :"0";
            }

            if (rdnAll.Checked)
                ClsParameterFileFormatControl.ssExportType = "All";
            else
                ClsParameterFileFormatControl.ssExportType = "Count";



            //ClsParameterFileFormatControl.defaultComType = rdbMSExcel.Checked ? 0 : 1;
            //ClsParameterFileFormatControl.defaultOutputCursorKeyType = rdnAll.Checked ? 0 : 1;
            txtFileSaveDir.Text = txtFileSaveDir.Text.Trim();
            if (txtFileSaveDir.Text.Length > 0)
                ClsParameterFileFormatControl.ssFileSaveDir = txtFileSaveDir.Text.Trim();
            else
                ClsParameterFileFormatControl.ssFileSaveDir = ClsGlobal.xmlConfigPath;
            

            try
            {
                Cursor.Current = Cursors.WaitCursor;
                
               
                ClsParameterFileFormatControl.Savevalues();
               

            }
            
            catch (System.Exception ee)
            {

                ClsFormInfo.ShowSaveFail(this, ee);             
                return;
            }
            finally
            {
                Cursor.Current = Cursors.Default;
            }
           
            this.DialogResult = DialogResult.OK;
            ClsFormInfo.ShowEditSuccess(this);

           


        }

        private void button3_Click(object sender, EventArgs e)
        {
            Close();
        }

      

        private void button1_Click(object sender, EventArgs e)
        {
            //ClsParameterFileFormatControl.Freshvalues();
            ckbisDeleteExport.Checked = ClsParameterFileFormatControl.sisDeleteExport;
            
            ckbisDeleteExport_CheckedChanged(null, null);
            ckbisConfirminDelete.Checked = ClsParameterFileFormatControl.sisConfirminDelete;
            ckbisAllowEmpty.Checked = ClsParameterFileFormatControl.sisAllowEmpty;
            
            if (ClsParameterFileFormatControl.ssFileType.Equals("MSExcel"))
                rdbMSExcel.Checked = true;
            if (ClsParameterFileFormatControl.ssFileType.Equals("CSV"))
                rdbCSV.Checked = true;
            if (ClsParameterFileFormatControl.ssFileType.Equals("TXT"))
                rdbText.Checked = true;
            if (ClsParameterFileFormatControl.ssFileType.Equals("XML"))
                rdbXML.Checked = true;

            cmbdefaultSeparateChar.SelectedIndex = ClsParameterFileFormatControl.sidefaultSeparateChar;

            lvAvailable.Items.Clear();
            ListViewItem item;
            int len = ClsParameterFileFormatControl.sscColumnName.Count;
            for (int i = 0; i < len; i++)
            {
                item = new ListViewItem(ClsParameterFileFormatControl.sscColumnName[i].ToString());
                item.Tag = i;
                item.ImageIndex = 0;
                item.Checked = ClsParameterFileFormatControl.sscColumnSelected[i].ToString().Equals("1");
                lvAvailable.Items.Add(item);
            }

            if (ClsParameterFileFormatControl.ssExportType.Equals("All"))
                rdnAll.Checked = true;
            else
                rdnCount.Checked = true;

            txtFileSaveDir.Text = ClsParameterFileFormatControl.ssFileSaveDir;
            rdbText_CheckedChanged(null, null);
            
           
        }
        
       



        private void btnSelectDir_Click(object sender, EventArgs e)
        {

            //folderBrowserDialog1.RootFolder = Environment.SpecialFolder.Recent;
            folderBrowserDialog1.SelectedPath = ClsGlobal.xmlConfigPath;
            DialogResult result =  folderBrowserDialog1.ShowDialog();
            if (result == DialogResult.OK)
                txtFileSaveDir.Text = folderBrowserDialog1.SelectedPath;
                
        }

        private void rdbText_CheckedChanged(object sender, EventArgs e)
        {
            cmbdefaultSeparateChar.Enabled = rdbText.Checked;
        }

        private void ckbisDeleteExport_CheckedChanged(object sender, EventArgs e)
        {
            ckbisConfirminDelete.Checked = ckbisDeleteExport.Checked;
            ckbisConfirminDelete.Enabled = ckbisDeleteExport.Checked;
        }

        private void cmbdefaultSeparateChar_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void dgFields_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }


     

       
    }
}