using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Boundary.EAI;
using DBAccess.EAI;
using Control.STK;


namespace Boundary.STK
{
    public partial class FrmParameterSample : Form
    {

        private ClsFormProcess2 pClsFormProcess;
        //private ClsSystemParameter pcontrol;
        public string OldSkinName;
        public FrmParameterSample()
        {
            InitializeComponent();
        }

        public ClsFormProcess2 getFormProcess()
        {
            if (pClsFormProcess == null)
                pClsFormProcess = new ClsFormProcess2(this, true);
            return pClsFormProcess;
        }

        private void FrmParameter_Load(object sender, EventArgs e)
        {

            if (pClsFormProcess == null)
                pClsFormProcess = new ClsFormProcess2(this, true);

            FillComPort();
            button1_Click(null, null);
            OldSkinName = ClsParameterControl.defaultSkinName;
            btnFileFormatSet.Visible = ClsGlobal.defaultCustomer.Equals(ClsGlobal.defaultCustomerBJHY);
            ckbGoodsHasTitle.Visible = ClsGlobal.defaultCustomer.Equals(ClsGlobal.defaultCustomerZMSOFT);
        }


        private void FillComPort()
        {
             cmbdefaultComPort.Items.Clear();

             string[] portnames = System.IO.Ports.SerialPort.GetPortNames();
            for (int i = 0; i < portnames.Length; i++)
            {
                cmbdefaultComPort.Items.Add(portnames[i]);
            }
            if (cmbdefaultComPort.Items.Count == 1)
                cmbdefaultComPort.SelectedIndex = 0;
        }

       
        private void button4_Click(object sender, EventArgs e)
        {
            //ADODB._Connection ADOConn;
            //MSDASC.DataLinks dbDialog = new MSDASC.DataLinks();
            //ADOConn = (ADODB._Connection)dbDialog.PromptNew();
            //if (ADOConn != null)
            //{
            //    ClsDataConnect.SaveConnection(ADOConn.ConnectionString);
            //    ClsGlobal.objDataConnect.XMLDataConnect();
            //}

            ClsParameterControl.isLocalBackup = ckbisLocalBackup.Checked;
            ClsParameterControl.isOutputCursorKey = ckbisOutputCursorKey.Checked;
            ClsParameterControl.isAutoRunOnStart = ckbisAutoRunOnStart.Checked;
            ClsParameterControl.isBarcodeRepeat = ckbisBarcodeRepeat.Checked;

            ClsParameterControl.defaultComPort = cmbdefaultComPort.Text;
            ClsParameterControl.defaultInterfaceType = cmbdefaultInterfaceType.Text;


            if (cmbdefaultSkinName.SelectedIndex == -1)
                cmbdefaultSkinName.SelectedIndex = 0;
            ClsParameterControl.defaultSkinName = cmbdefaultSkinFile.Items[cmbdefaultSkinName.SelectedIndex].ToString();

            ClsParameterControl.defaultComType = rdbBluetooth.Checked ? 0 : 1;
            ClsParameterControl.defaultOutputCursorKeyType = rdnBarcodeNum.Checked ? 0 : 1;

            if (cmbdefaultUsedSoftware.SelectedIndex == -1)
                cmbdefaultUsedSoftware.SelectedIndex = 0;
            ClsParameterControl.defaultUsedSoftware = cmbdefaultUsedSoftwareFlag.Items[cmbdefaultUsedSoftware.SelectedIndex].ToString();
            ClsParameterControl.isInsertSoftwareDB = ckbisInsertSoftwareDB.Checked;

            ClsParameterControl.defaultNumber = cmbdefaultNumber.SelectedIndex;
            ClsParameterControl.hasNumberDigit = ckbhasNumberDigit.Checked;


            string temp = cmbdefaultTransFileVer.Items[cmbdefaultUsedSoftware.SelectedIndex].ToString();
            string[] values = temp.Split(';');
            ClsParameterControl.defaultTransFileVer = values[0];// cmbdefaultTransFileVer.Items[cmbdefaultUsedSoftware.SelectedIndex].ToString();
            ClsParameterControl.defaultConnection = int.Parse(values[1]);//

            ClsParameterControl.isLocalQuery = ckbisLocalQuery.Checked;
            ClsParameterControl.isInsertDB = ckbInsertDB.Checked;

            if (ClsGlobal.defaultCustomer.Equals(ClsGlobal.defaultCustomerZMSOFT))
            {
                ClsFileFormatControl FileFormatControl = new ClsFileFormatControl();
                temp = ckbGoodsHasTitle.Checked ? "Y" : "N";
                FileFormatControl.updateFileFormatValue("GOODSIN", "HASTITLE", temp);
            }
            try
            {
                Cursor.Current = Cursors.WaitCursor;
                ClsParameterControl.Savevalues();
               

            }
            
            catch (System.Exception ee)
            {

                ClsFormInfo.ShowSaveFail(this, ee);                
                return;
            }
            finally
            {
                Cursor.Current = Cursors.Default;
            }
            ClsParameterControl.FreshGlobalValues();
            this.DialogResult = DialogResult.OK;
            ClsFormInfo.ShowEditSuccess(this);
            
           


        }

        private void button3_Click(object sender, EventArgs e)
        {
            Close();
        }

      

        private void button1_Click(object sender, EventArgs e)
        {
            ClsParameterControl.initValues();//.Freshvalues();
            
            ckbisOutputCursorKey.Checked = ClsParameterControl.isOutputCursorKey;
            ckbisAutoRunOnStart.Checked = ClsParameterControl.isAutoRunOnStart;
            ckbisBarcodeRepeat.Checked = ClsParameterControl.isBarcodeRepeat;

            cmbdefaultInterfaceType.SelectedIndex = cmbdefaultInterfaceType.Items.IndexOf(ClsParameterControl.defaultInterfaceType);
            cmbdefaultComPort.SelectedIndex = cmbdefaultComPort.Items.IndexOf(ClsParameterControl.defaultComPort);
            cmbdefaultSkinName.SelectedIndex = cmbdefaultSkinFile.Items.IndexOf(ClsParameterControl.defaultSkinName);
            cmbdefaultUsedSoftware.SelectedIndex = cmbdefaultUsedSoftwareFlag.Items.IndexOf(ClsParameterControl.defaultUsedSoftware);
            cmbdefaultUsedSoftware_SelectedIndexChanged(null, null);
            ckbisInsertSoftwareDB.Checked = ClsParameterControl.isInsertSoftwareDB;
            ckbisLocalBackup.Checked = ClsParameterControl.isLocalBackup;
            if (ClsParameterControl.defaultComType == 0)
                rdbBluetooth.Checked = true;
            else
                rdb433.Checked = true;
            if (ClsParameterControl.defaultOutputCursorKeyType == 0)
                rdnBarcodeNum.Checked = true;
            else
                rdnBarcode.Checked = true;


            cmbdefaultNumber.SelectedIndex = ClsParameterControl.defaultNumber;
            ckbhasNumberDigit.Checked = ClsParameterControl.hasNumberDigit;

            ckbisLocalQuery.Checked = true;// ClsParameterControl.isLocalQuery;
            ckbInsertDB.Checked = false;// ClsParameterControl.isInsertDB;
            if (ClsGlobal.defaultCustomer.Equals(ClsGlobal.defaultCustomerZMSOFT))
            {
                ckbisOutputCursorKey.Checked = true;
                rdnBarcode.Checked = true;
                ClsFileFormatControl FileFormatControl  = new ClsFileFormatControl();

                ckbGoodsHasTitle.Checked = FileFormatControl.getFileFormatValue("GOODSIN", "HASTITLE").Equals("Y");
            }
        }
        
       

        private void ckbisOutputCursorKey_CheckedChanged(object sender, EventArgs e)
        {
            groupBox2.Enabled = ckbisOutputCursorKey.Checked;
        }

        private void ckbisLocalBackup_CheckedChanged(object sender, EventArgs e)
        {
            ckbisBarcodeRepeat.Enabled = ckbisLocalBackup.Checked;
        }

       
       

        private void btnSetDBString_Click(object sender, EventArgs e)
        {
            string usedsoftware = cmbdefaultUsedSoftwareFlag.Items[cmbdefaultUsedSoftware.SelectedIndex].ToString();
            if (usedsoftware.Substring(0, 3).Equals("WEB"))
            {
                //


                FrmParameterURL pFrmParameter = new FrmParameterURL();

                // pFrmParameter.MdiParent = this;
                pFrmParameter.ShowDialog();
            }
            else
            {
                //ݿ
                ClsGlobal.objDataConnect = new ClsDataConnect(true);
                //ClsDataConnect.XMLChangeConnectString();
                //ClsGlobal.objDataConnect.XMLDataConnect(); 
            }
            
        }

        private void cmbdefaultUsedSoftware_SelectedIndexChanged(object sender, EventArgs e)
        {
            //if (cmbdefaultUsedSoftware.SelectedIndex == 0)
            //{
            //    ckbisInsertSoftwareDB.Checked = false;
            //    //btnSetDBString.Enabled = false;
            //    //ckbisInsertSoftwareDB.Enabled = false;
            //    //ckbisLocalQuery.Checked = false;
            //}
            //else
            //{
            //    ckbisInsertSoftwareDB.Checked = true;
            //    //btnSetDBString.Enabled = true;
            //    //ckbisInsertSoftwareDB.Enabled = true;
            //}
            string usedsoftware = cmbdefaultUsedSoftwareFlag.Items[cmbdefaultUsedSoftware.SelectedIndex].ToString();
            if (usedsoftware.Substring(0, 3).Equals("WEB"))
            {
                //
                btnSetDBString.Text = TOTA.Properties.Resources.rsWebConnect;// "web";

            }
            else
            {
                //ݿ
                btnSetDBString.Text = TOTA.Properties.Resources.rsDBConnect;//  "ݿ";
            }
            //}
            //btnSetDBString.Enabled = cmbdefaultUsedSoftware.SelectedIndex>0;
            //ckbisInsertSoftwareDB.Enabled = cmbdefaultUsedSoftware.SelectedIndex > 0;
            

        }

        private void button2_Click(object sender, EventArgs e)
        {

           
                FrmParameterFile2 pFrmParameter = new FrmParameterFile2();

                // FrmParameterFile.MdiParent = this;
                pFrmParameter.ShowDialog();
           
            //if (pFrmParameter.DialogResult == DialogResult.OK && ClsGlobal.defaultSkinName != pFrmParameter.OldSkinName)
            //    skinEngine1.SkinFile = ClsGlobal.defaultSkinName;
        }

        //private static System.Diagnostics.Process Land433, Landblue;
        private void btnSetup_Click(object sender, EventArgs e)
        {


            Frm433Setup pFrmParameter = new Frm433Setup();            
            pFrmParameter.ShowDialog();
            // try
            //{
            //    if (Land433 == null)
            //    {
            //        Land433 = new System.Diagnostics.Process();
            //        Land433.StartInfo.FileName = "Setup433.exe";
            //        Land433.Start();
            //    }
            //    else
            //    {
            //        if (Land433.HasExited)  //Ƿ
            //        {
            //            Land433.Start();
            //        }
            //    }
            //}
            //catch (Exception ee)
            //{
            //    ClsFormInfo.ShowError(this, "г", ee);    
                
            //}


        }

        private void label4_Click(object sender, EventArgs e)
        {

        }

        private void cmbdefaultNumber_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void ckbisInsertSoftwareDB_CheckedChanged(object sender, EventArgs e)
        {
            if (ckbisInsertSoftwareDB.Checked)
            {
            }
            else
            {
                ckbisLocalQuery.Checked = true;
                ckbisLocalBackup.Checked = true;
                ckbInsertDB.Checked = false;
            }
        }

        private void ckbInsertDB_CheckedChanged(object sender, EventArgs e)
        {
            if (ckbisInsertSoftwareDB.Checked)
            {
            }
            else
            {                
                ckbInsertDB.Checked = false;
            }
        }

        private void cmbdefaultComPort_Enter(object sender, EventArgs e)
        {
            FillComPort();
        }

       

     

       
    }
}