using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Control.STK
{
    public class clsRealTimeIntf
    {





        //


        [DllImport("OBMSLABHIDDevice.dll", EntryPoint = "GetOpenCode")]
        public static unsafe extern void GetOpenCode(byte[] data);


        [DllImport("OBMSLABHIDDevice.dll", EntryPoint = "GetCloseCode")]
        public static unsafe extern void GetCloseCode(byte[] data);


        [DllImport("OBMSLABHIDDevice.dll", EntryPoint = "CheckData")]
        public static unsafe extern int CheckData(byte[] data, int nBytesCount);

        [DllImport("OBMSLABHIDDevice.dll", EntryPoint = "AnalyseData")]
        public static unsafe extern int AnalyseData_1(byte[] data, int nBytesCount, int isUSBUPLoad, byte[] sendData, byte[] outData);

        [DllImport("OBMSLABHIDDevice.dll", EntryPoint = "AnalyseData2")]
        public static unsafe extern int AnalyseData_2(byte[] data, int nBytesCount, int isUSBUPLoad, byte[] sendData, byte[] outData);
          


        [DllImport("OBMSLABHIDDevice.dll", EntryPoint = "AnalyseQueryData")]
        public static unsafe extern int AnalyseQueryData2(byte[] data, int nBytesCount, byte[] sendData, byte[] outData);
          


        [DllImport("OBMSLABHIDDevice.dll", EntryPoint = "ReturnGoodsInfo")]
        public static unsafe extern int ReturnGoodsInfo2(byte[] data, int start,string  strGoodname,string strSpec, string strUnit,string  strStockQty, string strInPrice, string  strOutPrice);


        [DllImport("OBMSLABHIDDevice.dll", EntryPoint = "ImportText")]
        public static unsafe extern int ImportText(string filename, int hastitle, string strSeparator);

        [DllImport("OBMSLABHIDDevice.dll", EntryPoint = "ImportText2")]
        public static unsafe extern int ImportText2(string filename, int hastitle, string strSeparator);

        


        public static bool AnalyseData(byte[] data, int nBytesCount, bool isUSBUPLoad, byte[] SendData,
           ref  string barcode, ref  string lotno, ref  string selfID, ref double qty, ref double price, ref int nType, ref int nChannel, ref uint nSerial, ref  string cOPTime)
        {       
            int result = 0;

            byte[] outdata = new byte[256], tempdata = new byte[128];

            int usbupload = 0;
            if (isUSBUPLoad)
                usbupload = 1;
            unsafe
            {
                result = AnalyseData_1(data, nBytesCount, usbupload, SendData, outdata);//barcode, lotno, selfID, cqty, cprice, cType, cChannel, cSerial, cOPTime);
                //char* cBarcode, char* cSelfID, char* cLotNo,char* cQty, char*  cPrice, char*  cDataType, char* cChannel,char* cSerial,char*  cOPTime)
            }
            if (result < 0)
                return false;
            int col = 0;
            int start = 0;
            Encoding encoding = Encoding.UTF8;//.Default;
            for (int i = 0; i < outdata.Length; i++)
            {
                if (outdata[i] == 0x00)//
                    break;
                if (outdata[i] == 0x01)//ָ
                {
                    switch (col)
                    {
                        case 0:
                            barcode = encoding.GetString(tempdata, 0, start);
                            barcode = barcode.Trim();
                            break;
                        case 1:
                            selfID = encoding.GetString(tempdata, 0, start);
                            selfID = selfID.Trim();
                            break;
                        case 2:
                            lotno = encoding.GetString(tempdata, 0, start);
                            lotno = lotno.Trim();
                            break;
                        case 3:
                            try
                            {
                                qty = double.Parse(encoding.GetString(tempdata, 0, start));
                            }
                            catch
                            {
                                qty = 0;
                            }
                            break;
                        case 4:
                            try
                            {
                                price = double.Parse(encoding.GetString(tempdata, 0, start));
                            }
                            catch
                            {
                                price = 0;
                            }
                            break;
                        case 5:
                            try
                            {
                                nType = int.Parse(encoding.GetString(tempdata, 0, start));
                            }
                            catch
                            {
                                nType = 0;
                            }
                            break;
                        case 6:
                            try
                            {
                                nChannel = int.Parse(encoding.GetString(tempdata, 0, start));
                            }
                            catch
                            {
                                nChannel = 0;
                            }
                            break;
                        case 7:
                            try
                            {
                                nSerial = uint.Parse(encoding.GetString(tempdata, 0, start));
                            }
                            catch
                            {
                                nSerial = 0;
                            }
                            break;
                        case 8:
                            cOPTime = encoding.GetString(tempdata, 0, start);
                            cOPTime = cOPTime.Trim();
                            break;
                    }
                    start = 0;
                    col++;
                }
                else
                {
                    tempdata[start] = outdata[i];
                    start++;
                }

            }
            //qty = double.Parse(cqty);
            //price = double.Parse(cprice);
            //nType = int.Parse(cType);
            //nChannel = int.Parse(cChannel);
            //nSerial = uint.Parse(cSerial);
            return true;          
        }


        public static bool AnalyseData2(byte[] data, int nBytesCount, bool isUSBUPLoad, byte[] SendData,
           ref  string barcode, ref  string lotno, ref string productDate, ref string expireDate, ref  string selfID, ref string cBill, ref double qty, ref double price, ref int nType,
            ref int nChannel, ref uint nSerial, ref  string cOPTime, ref string cmachine)
        {
            int result = 0;

            byte[] outdata = new byte[256], tempdata = new byte[128];

            int usbupload = 0;
            if (isUSBUPLoad)
                usbupload = 1;
            unsafe
            {
                result = AnalyseData_2(data, nBytesCount, usbupload, SendData, outdata);//barcode, lotno, selfID, cqty, cprice, cType, cChannel, cSerial, cOPTime);
                //char* cBarcode, char* cSelfID, char* cLotNo,char* cQty, char*  cPrice, char*  cDataType, char* cChannel,char* cSerial,char*  cOPTime)
            }
            if (result < 0)
                return false;
            int col = 0;
            int start = 0;
            Encoding encoding = Encoding.UTF8;//.Default;
            for (int i = 0; i < outdata.Length; i++)
            {
                if (outdata[i] == 0x00)//
                    break;
                if (outdata[i] == 0x01)//ָ
                {
                    switch (col)
                    {
                        case 0:
                            barcode = encoding.GetString(tempdata, 0, start);
                            barcode = barcode.Trim();
                            break;
                        case 1:
                            selfID = encoding.GetString(tempdata, 0, start);
                            selfID = selfID.Trim();
                            break;
                        case 2:
                            lotno = encoding.GetString(tempdata, 0, start);
                            lotno = lotno.Trim();
                            break;
                        case 3:
                            productDate = encoding.GetString(tempdata, 0, start);
                            productDate = productDate.Trim();
                            break;
                        case 4:
                            expireDate = encoding.GetString(tempdata, 0, start);
                            expireDate = expireDate.Trim();
                            break;
                        case 5:
                            cBill = encoding.GetString(tempdata, 0, start);
                            cBill = cBill.Trim();
                            break;
                        case 6:
                            cmachine = encoding.GetString(tempdata, 0, start);
                            cmachine = cmachine.Trim();
                            break;
                        case 7:
                            try
                            {
                                qty = double.Parse(encoding.GetString(tempdata, 0, start));
                            }
                            catch
                            {
                                qty = 0;
                            }
                            break;
                        case 8:
                            try
                            {
                                price = double.Parse(encoding.GetString(tempdata, 0, start));
                            }
                            catch
                            {
                                price = 0;
                            }
                            break;
                        case 9:
                            try
                            {
                                nType = int.Parse(encoding.GetString(tempdata, 0, start));
                            }
                            catch
                            {
                                nType = 0;
                            }
                            break;
                        case 10:
                            try
                            {
                                nChannel = int.Parse(encoding.GetString(tempdata, 0, start));
                            }
                            catch
                            {
                                nChannel = 0;
                            }
                            break;
                        case 11:
                            try
                            {
                                nSerial = uint.Parse(encoding.GetString(tempdata, 0, start));
                            }
                            catch
                            {
                                nSerial = 0;
                            }
                            break;
                        case 12:
                            cOPTime = encoding.GetString(tempdata, 0, start);
                            cOPTime = cOPTime.Trim();
                            break;

                    }
                    start = 0;
                    col++;
                }
                else
                {
                    tempdata[start] = outdata[i];
                    start++;
                }

            }
            //qty = double.Parse(cqty);
            //price = double.Parse(cprice);
            //nType = int.Parse(cType);
            //nChannel = int.Parse(cChannel);
            //nSerial = uint.Parse(cSerial);
            return true;
        }


        public static int AnalyseQueryData(byte[] data, int nBytesCount, byte[] SendData, ref string barcode, ref string lotno, ref string selfID,
            ref int nType, ref int nDataType, ref int nChannel, ref uint nSerial, ref string starttime, ref string endtime)
        {
            int result = 0;

            byte[] outdata = new byte[256], tempdata = new byte[128];            
          
            unsafe
            {
                result = AnalyseQueryData2(data, nBytesCount, SendData,outdata);
            }
            if (result < 0)
                return result;

            int col = 0;
            int start = 0;
            Encoding encoding = Encoding.UTF8;//.Default;
            for (int i = 0; i < outdata.Length; i++)
            {
                if (outdata[i] == 0x00)//
                    break;
                if (outdata[i] == 0x01)//ָ
                {//char*  cBarcode,char*  cSelfID, char*  cLotNo,char*  cOPType,char*  cDataType, char* cChannel,char* cSerial,char* cStartTime, char*  cEndTime)
                    switch (col)
                    {
                        case 0:
                            barcode = encoding.GetString(tempdata, 0, start);
                            barcode = barcode.Trim();
                            break;
                        case 1:
                            selfID = encoding.GetString(tempdata, 0, start);
                            selfID = selfID.Trim();
                            break;
                        case 2:
                            lotno = encoding.GetString(tempdata, 0, start);
                            lotno = lotno.Trim();
                            break;
                        case 3:
                            try
                            {
                                nType = int.Parse(encoding.GetString(tempdata, 0, start));
                            }
                            catch
                            {
                                nType = 0;
                            }
                            break;
                        case 4:
                            try
                            {
                                nDataType = int.Parse(encoding.GetString(tempdata, 0, start));
                            }
                            catch
                            {
                                nDataType = 0;
                            }
                            break;                     
                        case 5:
                            try
                            {
                                nChannel = int.Parse(encoding.GetString(tempdata, 0, start));
                            }
                            catch
                            {
                                nChannel = 0;
                            }
                            break;
                        case 6:
                            try
                            {
                                nSerial = uint.Parse(encoding.GetString(tempdata, 0, start));
                            }
                            catch
                            {
                                nSerial = 0;
                            }
                            break;
                        case 7:
                            starttime = encoding.GetString(tempdata, 0, start);
                            starttime = starttime.Trim();
                            break;
                        case 8:
                            endtime = encoding.GetString(tempdata, 0, start);
                            endtime = endtime.Trim();
                            break;

                    }
                    start = 0;
                    col++;
                }
                else
                {
                    tempdata[start] = outdata[i];
                    start++;
                }

            }
            
                

            return result;
        }



        public static int ReturnGoodsInfo(byte[] data, int start, string strgoodname, string strspec, string strunit, double stockqty, double inprice, double outprice)
        {
            //string cstockqty = string.Empty;
            //string cinprice = string.Empty;
            //string coutprice = string.Empty;
            int result = ReturnGoodsInfo2(data, start, strgoodname, strspec, strunit, stockqty.ToString(), inprice.ToString(), outprice.ToString());
            //stockqty = double.Parse(cstockqty);
            //inprice = double.Parse(cinprice);
            //outprice = double.Parse(coutprice);
            return result;

        }
           
    }

   
 


}
