
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.IO.Ports;
using System.Collections;
using System.Threading;
using System.Text;
using System.Data;
using System.Data.OleDb;
using System.IO;
using System.Runtime.InteropServices;
using DBAccess.EAI;
using System.Reflection;
using Entity.STK;
using Boundary.EAI;
using Control.STK;
using System.Globalization;

namespace Boundary.STK
{
    public partial class frmMain : Form
    {
    
        
        private AboutUS pAboutWMS;
        
        private FrmParameterSample pFrmParameterS;
        private frmQuery pfrmQuery;
        
        

        private ClsScanDataControl objControl = new ClsScanDataControl();
        struct sLastSerial
        {
            public byte cPosID;
            public int nLaseSerial;
            public string sOPTime;
            public int nLaseQuerySerial;
            public Byte[] SendData;
            public int returnlen;
        };
   
        sLastSerial[] psLastSerial = new sLastSerial[100];

        ClsDataQueryControl objDataQueryControl = new ClsDataQueryControl();
        
        private const int ReadLength = 1024;
        private ISTKSaveDBInterface iSaveDB = null;
        private int m_nStartFlag = 0;
        private bool threadrunflag = false;//false-ֹͣ

        private ClsFormProcess2 pClsFormProcess;
        private int languagetype=0;
        private int receivetype = 0;//1:433m;2:USB

        public frmMain()
        {
            InitializeComponent();
            
        }

        public string AssemblyTrademark
        {
            get
            {
                // ȡ˳򼯵 Trademark 
                object[] attributes = Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyTrademarkAttribute), false);
                //  Trademark Բڣ򷵻һַ
                if (attributes.Length == 0)
                    return "";
                //  Trademark ԣ򷵻ظԵֵ
                return ((AssemblyTrademarkAttribute)attributes[0]).Trademark;
            }
        }

        public string AssemblyTitle
        {
            get
            {
                // ȡ˳ϵ Title 
                object[] attributes = Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyTitleAttribute), false);
                // һ Title 
                if (attributes.Length > 0)
                {
                    
                    // ѡһ
                    AssemblyTitleAttribute titleAttribute = (AssemblyTitleAttribute)attributes[0];
                    // Ϊǿַ䷵
                    if (titleAttribute.Title != "")
                        return titleAttribute.Title;
                }
                // û Title ԣ Title Ϊһַ򷵻 .exe 
                return System.IO.Path.GetFileNameWithoutExtension(Assembly.GetExecutingAssembly().CodeBase);
            }
        }

        private void setShowMenu()
        {
            ClsParameterControl.Freshvalues();
            ClsParameterControl.FreshGlobalValues();
            
            tsBtnSetup.Visible = true;
            tsmiFileFormat.Visible = true;
            
            //tsmiDownloadDB.Visible = true;
            tsmiLanguage.Visible = true;
            tsbtnDownload.Visible = true;
          //  tsbtnClose.Visible = true;
            tsBtnSetup.Visible = true;
            tsBtnQuery.Visible = true;
            //tsmiUpUSBData.Visible = true;
            //tsbtnReceiveUSB.Visible = false;
            tsmiDownloadDB.Visible = ClsGlobal.isInsertSoftwareDB;
            tsmiImportFile.Visible = !ClsGlobal.isInsertSoftwareDB;
            tsmiImportFile.Visible = !ClsGlobal.isInsertSoftwareDB;
            tsmiDownloadLocal.Visible = !ClsGlobal.isInsertSoftwareDB;

            tsbtnReceiveUSB.Visible = true;
            tsmiGoodsQuery.Visible = true;

            tsmiDownFile.Visible = false;
            tsmiUpUSBData.Visible = false;
            tsmiDownloadBill.Visible = false;

            /////////////
            tsmiFileFormat.Visible = false;
            tsmiImportFile.Visible = false;
            tsmiDownloadDB.Visible = false;
            tsmiLanguage.Visible = false;
            tsmiImportFile.Visible = false;

            tsBtnSetup.Visible = false;

            
            tsBtnQuery.Visible = false;
            tsmiGoodsQuery.Visible = false;
            tsmiDownloadLocal.Visible = false;

        }

        private void frmMain_Load(object sender, EventArgs e)
        {
            ClsGlobal.defaultSystemNo = ClsGlobal.defaultSystemNo767;
            ClsGlobal.appicon = ((System.Drawing.Icon)TOTA.Properties.ImgResources.form_Icon);
            if (pClsFormProcess == null)
                pClsFormProcess = new ClsFormProcess2(this, true);
            ClsGlobal.objTempDataConnect = new DBAccess.EAI.ClsOleDataHepler();
            
            this.skinEngine1.SkinFile = ClsGlobal.defaultSkinName;           
            //tsmiDownloadDB.Visible = ClsGlobal.isInsertSoftwareDB;
            setShowMenu();
            
           
           
            for (int i = 0; i < 100; i++)
            {
                psLastSerial[i].cPosID = (byte)i;
                psLastSerial[i].nLaseSerial = -1;
                psLastSerial[i].nLaseQuerySerial = -1;
                psLastSerial[i].returnlen = 0;
            }
            listView2.Items.Clear();
            
           


            
            if (Thread.CurrentThread.CurrentCulture.Name.ToLower().IndexOf("zh-cn") >= 0)
            {
                languagetype = 0;
                helpToolStripMenuItem.Visible = true;
                Thread.CurrentThread.CurrentUICulture = new CultureInfo("");
            }
            else
            {
                languagetype = 1;
                helpToolStripMenuItem.Visible = false;
                Thread.CurrentThread.CurrentUICulture = new CultureInfo("en");               
               
            }
            ClsGlobal.AppCultureInfo = Thread.CurrentThread.CurrentUICulture;
            TOTA.Properties.Resources.Culture = Thread.CurrentThread.CurrentUICulture;

            if (languagetype == 0)
                this.Text = AssemblyTitle;
            else
                this.Text = AssemblyTrademark;

            setStateMode(false);
            if (ClsGlobal.isAutoRunOnStart)
            {
                
                
                tsbtnOpen_Click(null, null);

                
            }
            tsmiSave.Visible = ClsGlobal.isDevelop;
        }

        private void MinimizeForm()
        {
            this.Hide();
            this.notifyIcon1.Visible = true;
            this.notifyIcon1.ShowBalloonTip(30);//, notifyIcon1.BalloonTipTitle, notifyIcon1.BalloonTipText, notifyIcon1.BalloonTipIcon);

            
        }

        //#region         дWndProcεرհť
        //protected override void WndProc(ref Message m)
        //{
        //    const int WM_SYSCOMMAND = 0x0112;
        //    const int SC_CLOSE = 0xF060;
        //    if (m.Msg == WM_SYSCOMMAND && (int)m.WParam == SC_CLOSE) //&& ClsGlobal.isAutoRunOnStart
        //    {
        //        this.WindowState = FormWindowState.Minimized;
        //        return;
        //    }
        //    base.WndProc(ref m);
        //}
        //#endregion


        #region MenuStrip
        private void exitToolStripMenuItem_Click(object sender, EventArgs e)//Exit
        {
            tsbtnExit_Click(sender, e);//Exit
        }
        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)//About
        {
            if (pAboutWMS != null && !pAboutWMS.IsDisposed)
            {
                pAboutWMS.Close();
                pAboutWMS = null;
            }
            pAboutWMS = new AboutUS();

            // pAboutWMS.MdiParent = this;
            pAboutWMS.ShowDialog();
        }
        #endregion

        #region ToolStrip

        private void openconnect()
        {
            if (ClsGlobal.isInsertSoftwareDB)//ClsGlobal.defaultUsedSoftware != "default" &&
            {
                //DialogResult result = ClsFormInfo.ShowConfirm(this, TOTA.Properties.Resources.rsisInsertSoftwareDB);
                //if (result != DialogResult.OK)
                //{
                //    return;
                //}
                if (ClsGlobal.defaultUsedSoftware.Substring(0, 3).Equals("WEB"))
                {
                    //

                }
                else
                {
                    //ݿ
                    if (ClsGlobal.objDataConnect == null)
                    {
                        toolStripStatusLabel3.Text = TOTA.Properties.Resources.rsConnectDB;// "ӿڵݿ...";
                        ClsGlobal.objDataConnect = new ClsDataConnect("connectionstring");
                        if (ClsGlobal.objDataConnect == null)
                        {
                            toolStripStatusLabel3.Text = "";
                            ShowInfo( TOTA.Properties.Resources.rsConnectDBFail);
                            return;
                        }
                        toolStripStatusLabel3.Text = TOTA.Properties.Resources.rsConnectDBSuccess;

                    }
                }
                iSaveDB = DataAccess.CreateSTKSaveDBInterface();
            }
        }
        private void tsbtnOpen_Click(object sender, EventArgs e)//Open
        {

            //if (ClsGlobal.defaultCustomer.Equals(ClsGlobal.defaultCustomerZMSOFT))//
            //{

            //    return;
            //}

           


            ////////////////////////////
            openconnect();
           
           // string downladfilename;
           // downladfilename = @"E:\˾ļ\OBM767\OBM767\OBM767\bin\Debug\update.bin";




            //cfilename = filename.ToCharArray(); //System.Text.Encoding.Default.GetBytes(filename);
            // char* c = cfilename;//??????


            receivetype = 1;
            try
            {
                //if (serialPort1.IsOpen)
                //    serialPort1.Close();

                InitializeSerialPort();
                //serialPort1.ReceivedBytesThreshold = 1;
                

                serialPort1.RtsEnable = false;
                if (!serialPort1.IsOpen)
                    serialPort1.Open();
                serialPort1.DataReceived += new SerialDataReceivedEventHandler(serialPort_DataReceived);
                m_nStartFlag = 0;
                if (0 == ClsGlobal.defaultComType)
                {  //ʽĬƵΪ0
                    serialPort1.RtsEnable = true;
                   
                }
                else
                {
                    //433ʽӦȡƵ 
                    //Ϳ 3
                    serialPort1.RtsEnable = false;

                    Byte[] SendData = new byte[5];
                    clsRealTimeIntf.GetOpenCode(SendData);
                    //SendData[0] = 0xfd;                
                    //SendData[1] = 0xfc;                
                    //SendData[2] =  0xff;               
                    //SendData[3] =  0xfd;
                    //SendData[4] =  0xfc;
                    
                    for(int i=0; i<3; i++)
                    {
                        this.serialPort1.Write(SendData, 0,3);
                        Thread.Sleep(300);
                        Application.DoEvents();
                        //if(m_nStartFlag>0)
                        //    break;
                    }

                    if (m_nStartFlag == 0)
                    {
                        toolStripStatusLabel3.Text = TOTA.Properties.Resources.rsOpenPortNoRespond;// "Ӧ...";
                        ClsFormInfo.ShowError(this, TOTA.Properties.Resources.rsRespond);
                        tsbtnClose_Click(null, null);
                        return;
                    }
                    else
                    {
                        toolStripStatusLabel3.Text = TOTA.Properties.Resources.rsOpenPortSuccess;// "433Mӳɹ,ڹ...";
                    }
                }
                
                

                setStateMode(true);
                //tsbtnOpen.Enabled = false;                          
                
                //toolStripProgressBar1.Visible = true;
                //toolStripStatusLabel3.Text = "ڼ...";
            }
            catch (Exception ee)
            {
                setStateMode(false);
                //ClsFormInfo.LogError( ee);  
                ClsFormInfo.ShowError(this, TOTA.Properties.Resources.rsOpenComError, ee);                
            }
        }

        private void setStateMode(bool isOn)
        {
            tsbtnOpen.Enabled = !isOn;
            tsbtnDownload.Enabled = !isOn;
            tsbtnOpen.Enabled = !isOn;
            tsbtnClose.Enabled = isOn;
            tsbtnSystemSetup.Enabled = !isOn;
            tsBtnQuery.Enabled = !isOn;
            tsbtnExport.Enabled = !isOn;
            //tsbtnClear.Enabled = !isOn;
            tsbtnExit.Enabled = !isOn;
            tsbtnReceiveUSB.Enabled = !isOn;
            tsmiShow.Visible = true;
            tsmiRun.Visible = !isOn;
            tsmiPause.Visible = isOn;
            tsmiExit.Visible = !isOn;


            toolStripProgressBar1.Visible = false;// isOn;
            
            splitContainer2.Visible =(!ClsGlobal.defaultCustomer.Equals(ClsGlobal.defaultCustomerZMSOFT)) && isOn && (!threadrunflag);
            //toolStripProgressBar1.
            if (!isOn)                          
                toolStripStatusLabel3.Text = "ready";
            else
                toolStripStatusLabel3.Text = "start...";
        }

        private void tsbtnClose_Click(object sender, EventArgs e)//Close
        {
            if (serialPort1 != null && serialPort1.IsOpen )
            {
                try
                {

                    serialPort1.DataReceived -= new SerialDataReceivedEventHandler(serialPort_DataReceived);
                    //433ʽӦȡƵ   
                    Byte[] SendData = new byte[7];
                    clsRealTimeIntf.GetCloseCode(SendData);
                    //SendData[0] = 0xfd;
                    //SendData[1] = 0xfc;
                    //SendData[2] = 0x00;
                    //SendData[3] = 0xfd;
                    //SendData[4] = 0xfc;

                    m_nStartFlag = 0;

                    for (int i = 0; i < 3; i++)
                    {
                        this.serialPort1.Write(SendData, 0,3);
                        Thread.Sleep(100);
                        Application.DoEvents();
                        if (m_nStartFlag > 0)
                            break;
                    }

                    if (m_nStartFlag == 0)
                    {
                        toolStripStatusLabel3.Text = TOTA.Properties.Resources.rsOpenPortNoRespond;// "Ӧ...";
                        //ClsFormInfo.ShowError(this, TOTA.Properties.Resources.rsRespond);

                        //return;
                    }                      



                                                         
                    
                    serialPort1.Close();

                    

                    //tsbtnOpen.Enabled = true;

                }
                catch (Exception ee)
                {
                    ClsFormInfo.LogError(ee);
                    //ClsFormInfo.ShowError(this, TOTA.Properties.Resources.rsCloseComError, ee);
                }
                
                //toolStripProgressBar1.Visible = false;
                //toolStripStatusLabel3.Text = "Ready";
            }
            if (threadrunflag)
            {
                threadrunflag = false;
                Thread.Sleep(300);
            }
            //if (ClsGlobal.defaultCustomer.Equals(ClsGlobal.defaultCustomerZMSOFT) && receivetype==2)//USB
            //{
            //    string filename = saveFileDialog1.FileName;
            //    objControl.updateNullScanData();
            //    DataTable dt1 = objControl.GetAllData(1);
            //    DataTable dt = objControl.GetAllData(2);

            //    if (dt1.Rows.Count>0 || dt.Rows.Count > 0)
            //    {
            //        ClsZMFileOPControl opControl = new ClsZMFileOPControl();
            //        opControl.ExportText(filename,dt1, dt);

            //        if (dt1.Rows.Count > 0)
            //        {
            //            ShowInfo("ݲɹ:" + dt1.Rows.Count.ToString());
            //        }
            //        if (dt.Rows.Count > 0)
            //        {
            //            ShowInfo("̵ϴ¼:" + dt.Rows.Count.ToString());
            //        }
            //        ShowInfo(",ļ!");
            //    }
            //    else
            //    {
            //        ShowInfo("!");
            //    }

            //}
            receivetype = 0;
            setStateMode(false);
        }
        private void tsbtnExit_Click(object sender, EventArgs e)//Exit
        {
            this.Close();

        }
        private void tsbtnClear_Click(object sender, EventArgs e)//Clear All button
        {
            listView2.Items.Clear();
            //textBox1.Clear();
           
        }
       
        #region SerialPort's Settings
        
        public SerialPort SerialPort
        {
            get
            {
                return serialPort1;
            }
            set
            {
                serialPort1 = value;
            }
        }
       
        #endregion

        //Helper Method
        private void InitializeSerialPort()//Call all methods in Region: SerialPort's Settings to initialize the serial port
        {
            
                serialPort1.DataBits = 8;
                serialPort1.DiscardNull = false;
                serialPort1.DtrEnable = false;
                serialPort1.Handshake = Handshake.None;
                serialPort1.Parity = Parity.None;
                serialPort1.ParityReplace = Convert.ToByte("63");
                serialPort1.RtsEnable = false;
                serialPort1.StopBits = StopBits.One;
                if (serialPort1.PortName != ClsGlobal.defaultComPort)                                
                    serialPort1.PortName = ClsGlobal.defaultComPort;
                serialPort1.BaudRate = ClsGlobal.defaultBaudRate;
            
        }
        #endregion

        #region ContextMenuStrip
        private void clearToolStripMenuItem_Click(object sender, EventArgs e)//Clear (for listView2)
        {
            listView2.Items.Clear();
        }
      
        
        private void clearAllToolStripMenuItem_Click(object sender, EventArgs e)//Clear All (for listView2)
        {
            tsbtnClear_Click(sender, e);//Clear All button
        }
        private void clearAllToolStripMenuItem1_Click(object sender, EventArgs e)//Clear All (for textBox1)
        {
            tsbtnClear_Click(sender, e);//Clear All button
        }
        private void clearAllToolStripMenuItem2_Click(object sender, EventArgs e)//Clear All (for textBox2)
        {
            tsbtnClear_Click(sender, e);//Clear All button
        }
        
       
       
        #endregion


        #region Events
        //SerialPort data received event

        public void serialPort_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            if (!serialPort1.IsOpen)
                return;

            byte[] data = new byte[ReadLength];
           
            //Array.Clear(data, 0x00, data.Length); 
            //if (ClsGlobal.isDevelop)
            //{
            //    ShowTestInfo("ʼ");
            //}
            int nBytesCount = ReadLength;
            while (true)
            {
                nBytesCount = serialPort1.BytesToRead;
                Thread.Sleep(20);
                if (nBytesCount == serialPort1.BytesToRead)
                    break;
               
            }

            //int readcount = 0;
            if (nBytesCount >= ReadLength)
            {
                int nRemainCount = nBytesCount;
                nBytesCount = serialPort1.Read(data, 0, ReadLength);

                nRemainCount -= nBytesCount;
                byte[] datarest = new byte[ReadLength];
                while (nRemainCount > 0)
                {
                    if (nRemainCount > ReadLength)
                    {
                        serialPort1.Read(datarest, 0, ReadLength);
                        nRemainCount -= ReadLength;
                    }
                    else
                    {
                        serialPort1.Read(datarest, 0, nRemainCount);
                        nRemainCount = 0;
                    }
                   

                }
                if (ClsGlobal.isDevelop)
                {
                    ShowTestInfo(":");//
                }
                return;
            }
            else
            {

                nBytesCount = serialPort1.Read(data, 0, nBytesCount);
            }
            //if (nBytesCount != serialPort1.Read(data, 0, nBytesCount))
            //{serialPort1.Read(data, 0, ReadLength);
            //    return;
            //}
            //nBytesCount = serialPort1.Read(data, 0, ReadLength);
            //if (ClsGlobal.isDevelop)
            //{
            //    ShowTestInfo("ݳ:"+nBytesCount.ToString());
            //}
            
            
            
            //if (0 == ClsGlobal.defaultComType)
            //{  //ʽĬƵΪ0 
            //    m_nStartFlag++;
            //}
            //else
            //{  //433ʽӦȡƵ 

            //}
            receivedata(data, nBytesCount);

            

           
        }

        private void receivedata(byte[] data, int nBytesCount)
        {
            if (ClsGlobal.isDevelop)
            {
                ShowTestInfo("ݳ:" + nBytesCount.ToString() + ";" + ClsBitDataControl.GetAsciiString(data, nBytesCount));//
            }
            int nResult = clsRealTimeIntf.CheckData(data, nBytesCount);
            bool isprocess = true;
            switch ((byte)nResult)//
            {

                case ClsCOMMonitorControl.SHTP_OPEN: m_nStartFlag++; break;
                case ClsCOMMonitorControl.SHTP_CLOSE: m_nStartFlag++; break;
                case ClsCOMMonitorControl.SHTP_SETUPSYS:

                    break;//ϵͳӦ
                case ClsCOMMonitorControl.SHTP_REGCHANNEL:

                    break;//Ӧ
                case ClsCOMMonitorControl.SHTP_CANCELCHANNEL:

                    //ƵӦ
                    break;
                case ClsCOMMonitorControl.DATA_ERRFORMAT:
                    //֤ʧ
                    if (ClsGlobal.isDevelop)
                        ShowTestInfo("֤ʧ");
                    break;


                default:
                    isprocess = false;
                    break;
            }

            if (isprocess)
                return;

            int cType=0;
            int nDataType = 0;
            uint nSerial;
            int nChannel;
            byte convertresult = (byte)nResult;
            convertresult ^= ClsCOMMonitorControl.SHTP_DATACONVERT_FLAG;
            isprocess = true;
            Byte[] SendData;
            switch (convertresult)
            {

                case ClsCOMMonitorControl.SHTP_DATAUPLOAD://ϴ

                    //  
                    SendData = new byte[4];
                    ClsScanInfo lobj = new ClsScanInfo();

                    bool result = false;
                    result = clsRealTimeIntf.AnalyseData2(data, nBytesCount, false, SendData, ref lobj.cBarcode, ref lobj.cBatch, ref lobj.cProductDate, ref lobj.cExpireDate, ref lobj.cSelfID, ref lobj.cBill,
                            ref lobj.nAmount, ref lobj.nPrice, ref lobj.nOrginType, ref lobj.nChannel, ref lobj.nSerial, ref lobj.cOPTime, ref lobj.cMachineNo);

                   

                    this.serialPort1.Write(SendData, 0, 4);
                    lobj.dtReceive = DateTime.Now;

                    

                    if (psLastSerial[lobj.nChannel].nLaseSerial == (int)lobj.nSerial && psLastSerial[lobj.nChannel].sOPTime == lobj.cOPTime) //ظ
                    {


                        if (ClsGlobal.isDevelop) //ð
                        {

                            ShowRepeatInfo((int)lobj.nSerial);                           
                            
                        }
                        else//ʽ
                        {
                            break;
                        }

                    }
                    //if (!isUSBUPLoad)//UϴѾظ                
                    //    this.serialPort1.Write(SendData, 0, 4);

                    // Array.Copy(data, 2, SendData, 0, nBytesCount - 2);
                    psLastSerial[lobj.nChannel].nLaseSerial = (int)lobj.nSerial;
                    psLastSerial[lobj.nChannel].sOPTime = lobj.cOPTime;

                   
                

                    if (!result)
                    {
                        if (ClsGlobal.isDevelop) //ð
                        {

                            ShowTestInfo(TOTA.Properties.Resources.rsErrorLength);//"Ȳ");
                            break;

                        }

                    }
                    //switch (cType)
                    //{
                    //    case 0:
                    //    case 1:
                    //    case 2:
                    //    case 3:
                    //    case 4:

                    //        lobj.nType = objControl.gettypename((byte)cType); //Convert.ToString(cType + 1);
                    //        break;

                    //}
                    insertdata(lobj);
                    //ݴ
                    break;
                case ClsCOMMonitorControl.SHTP_DATAQUERY://ݲѯ
                    //
                    //queryData(data, nBytesCount,0);
                    
                    string barcode = string.Empty, lotno = string.Empty, selfID = string.Empty;
                    string starttime = string.Empty, endtime = string.Empty;
                    cType = 0x00;
                    nSerial = 0;
                    nChannel = 0;
                    SendData = new byte[4];
                    int returncol = clsRealTimeIntf.AnalyseQueryData(data, nBytesCount, SendData, ref barcode, ref lotno, ref selfID, ref cType, ref nDataType, ref nChannel, ref nSerial, ref starttime, ref endtime);
                    if ((psLastSerial[nChannel].nLaseQuerySerial == (int)nSerial) ) //ظ
                        //if ((psLastSerial[nChannel].nLaseQuerySerial == (int)nSerial) && (cType != 0x10)) //ظ
                    {


                        if (ClsGlobal.isDevelop) //ð
                        {

                            ShowRepeatInfo((int)nSerial);
                            ShowTestInfo("ͱ:" + psLastSerial[nChannel].returnlen.ToString() + ";" + ClsBitDataControl.GetAsciiString(psLastSerial[nChannel].SendData, psLastSerial[nChannel].returnlen));
                            //this.serialPort1.Write(SendData, 0, 4);

                        }
                        else//ʽ
                        {

                        }

                        this.serialPort1.Write(psLastSerial[nChannel].SendData, 0, psLastSerial[nChannel].returnlen);
                        // ShowTestInfo("ظ:" + psLastSerial[cPosID].returnlen.ToString() + ";" + objControl.GetAsciiString(psLastSerial[cPosID].SendData, psLastSerial[cPosID].returnlen));
                        break;

                    }
                    if (psLastSerial[nChannel].SendData == null)
                        psLastSerial[nChannel].SendData = new byte[256];
                    for (int i = 0; i < returncol; i++)
                    {
                        psLastSerial[nChannel].SendData[i] = SendData[i];
                    }
                    switch (cType)
                    {

                        case 0x10:
                          
                            string strgoodname = string.Empty, strspec = string.Empty, strunit = string.Empty;

                            Double stockqty = 0, inprice = 0, outprice = 0;

                            if (ckbIsNotQuery.Checked)//ѯ
                            {
                                strgoodname =TOTA.Properties.Resources.rsQueryEmptyGoodName;// "(δѯ)";
                                //objDataQueryControl.getGoodsInfo(psLastSerial[cPosID].SendData, returncol,  barcode, selfID, lotno,);
                            }
                            else
                            {
                                
                                objDataQueryControl.getGoodsInfo(ClsGlobal.isLocalQuery || !ClsGlobal.isInsertSoftwareDB, barcode, selfID, lotno, ref strgoodname, ref  strspec, ref  strunit, ref  stockqty, ref  inprice, ref  outprice);

                            }
                            psLastSerial[nChannel].returnlen = clsRealTimeIntf.ReturnGoodsInfo(psLastSerial[nChannel].SendData, returncol, strgoodname, strspec, strunit, stockqty, inprice, outprice);



                            break;

                        case 1:
                            psLastSerial[nChannel].returnlen = objDataQueryControl.getRecordChar(psLastSerial[nChannel].SendData, returncol);

                            break;
                        case 2:
                            //psLastSerial[nChannel].returnlen = objDataQueryControl.getTypeRecordChar(psLastSerial[nChannel].SendData, returncol, cType, barcode, string.Empty, string.Empty, string.Empty, string.Empty);
                           // break;
                        case 3:
                            //psLastSerial[nChannel].returnlen = objDataQueryControl.getTypeRecordChar(psLastSerial[nChannel].SendData, returncol, cType, barcode, starttime, endtime, string.Empty, string.Empty);
                           // break;
                        case 4:
                            psLastSerial[nChannel].returnlen = objDataQueryControl.getTypeRecordChar(psLastSerial[nChannel].SendData, returncol,(byte)nDataType, barcode, starttime, endtime, selfID, lotno);                           
                            break;
                       
                        default: return ;
                    }
                    serialPort1.Write(psLastSerial[nChannel].SendData, 0, psLastSerial[nChannel].returnlen);

                    if (ClsGlobal.isDevelop) //ð
                    {
                        ShowTestInfo(":" + psLastSerial[nChannel].returnlen.ToString() + ";" + ClsBitDataControl.GetAsciiString(psLastSerial[nChannel].SendData, psLastSerial[nChannel].returnlen));
                    }
                    psLastSerial[nChannel].nLaseQuerySerial = (int)nSerial;
                    break;
                case ClsCOMMonitorControl.SHTP_DATEDELETE://ɾ

                    break;
                case ClsCOMMonitorControl.SHTP_DATEMODIFY://޸

                    break;
                case ClsCOMMonitorControl.SHTP_DATADOWNGOODS://Ʒ


                    break;
                case ClsCOMMonitorControl.SHTP_DATAPROCEDURE://

                    break;

                case ClsCOMMonitorControl.SHTP_DATEOPENICON://ͼ

                    break;

                case ClsCOMMonitorControl.SHTP_DATECOLSEICON://ػͼ

                    break;


                default:
                    isprocess = false;
                    break;
            }
            if (isprocess)
                return;

            convertresult =(byte) nResult;
            convertresult ^= ClsCOMMonitorControl.SHTP_UCMDCONVERT_FLAG;
            isprocess = true;
            switch (convertresult)
            {
                case ClsCOMMonitorControl.UCMD_SEND://ϴ
                    //  
                    SendData = new byte[4];
                    ClsScanInfo lobj = new ClsScanInfo();

                    bool result = false;
                    result = clsRealTimeIntf.AnalyseData2(data, nBytesCount, true, SendData, ref lobj.cBarcode, ref lobj.cBatch, ref lobj.cProductDate, ref lobj.cExpireDate, ref lobj.cSelfID, ref lobj.cBill,
                             ref lobj.nAmount, ref lobj.nPrice, ref lobj.nOrginType, ref lobj.nChannel, ref lobj.nSerial, ref lobj.cOPTime, ref lobj.cMachineNo);

                    //analyseData(data, nBytesCount, false);
                    lobj.dtReceive = DateTime.Now;
                    if (psLastSerial[lobj.nChannel].nLaseSerial == (int)lobj.nSerial && psLastSerial[lobj.nChannel].sOPTime == lobj.cOPTime) //ظ
                    {


                        if (ClsGlobal.isDevelop) //ð
                        {

                            ShowRepeatInfo((int)lobj.nSerial);
                            //if (!isUSBUPLoad)//UϴѾظ      
                            // this.serialPort1.Write(SendData, 0, 4);
                        }
                        else//ʽ
                        {
                            break;
                        }

                    }
                    //if (!isUSBUPLoad)//UϴѾظ                
                    //    this.serialPort1.Write(SendData, 0, 4);

                    // Array.Copy(data, 2, SendData, 0, nBytesCount - 2);
                    psLastSerial[lobj.nChannel].nLaseSerial = (int)lobj.nSerial;
                    psLastSerial[lobj.nChannel].sOPTime = lobj.cOPTime;

                    if (!result)
                    {
                        if (ClsGlobal.isDevelop) //ð
                        {

                            ShowTestInfo(TOTA.Properties.Resources.rsErrorLength);//"Ȳ");
                            break;
                        }
                    }
                    //switch (cType)
                    //{
                    //    case 0:
                    //    case 1:
                    //    case 2:
                    //    case 3:
                    //    case 4:

                    //        lobj.nType = objControl.gettypename((byte)cType); //Convert.ToString(cType + 1);
                    //        break;

                    //}
                    insertdata(lobj);
                    //ݴ
                    break;
               

            }


        }

       

        private delegate bool ShowInfoCallback(string msg);
        private bool ShowInfo(string msg)
        {
            try
            {
                if (this.listView2.InvokeRequired)
                {

                    ShowInfoCallback d = new ShowInfoCallback(ShowInfo);
                    this.Invoke(d, new object[] { msg });

                }
                else
                {

                    int line = listView2.Items.Count;
                    ListViewItem listitem = new ListViewItem(new string[] { line.ToString(), string.Empty,string.Empty, msg, string.Empty, string.Empty, string.Empty, string.Empty, DateTime.Now.ToString(ClsGlobal.dtFormat + ".ffff") });

                    listView2.Items.Add(listitem);


                }
            }
            catch (Exception ee)
            {
                
                ClsFormInfo.ShowError(this, TOTA.Properties.CommResource.rsOPFail, ee);


                return false;
            }
            return true;

        }
       
        private delegate bool ShowTestInfoCallback(string msg);
        private bool ShowTestInfo(string msg)
        {
            try
            {
                if (this.listView2.InvokeRequired)
                {

                    ShowTestInfoCallback d = new ShowTestInfoCallback(ShowTestInfo);
                    this.Invoke(d, new object[] { msg });

                }
                else
                {

                    int line = listView2.Items.Count;
                    ListViewItem listitem = new ListViewItem(new string[] { line.ToString(),string.Empty, string.Empty, "յϢ", string.Empty, string.Empty, string.Empty, string.Empty, msg + "," + DateTime.Now.ToString(ClsGlobal.dtFormat + ".ffff") });

                    listView2.Items.Add(listitem);


                }
            }
            catch (Exception ee)
            {
                ClsFormInfo.ShowError(this, TOTA.Properties.CommResource.rsOPFail, ee);


                return false;
            }
            return true;

        }

        private delegate bool ShowRepeatInfoCallback( int serial);
        private bool ShowRepeatInfo(int serial)
        {
            try
            {
                if (this.listView2.InvokeRequired)
                {

                    ShowRepeatInfoCallback d = new ShowRepeatInfoCallback(ShowRepeatInfo);
                    this.Invoke(d, new object[] {   serial });

                }
                else
                {

                    int line = listView2.Items.Count;
                    ListViewItem listitem = new ListViewItem(new string[] { line.ToString(),string.Empty, string.Empty,TOTA.Properties.Resources.rsTransRepeat, string.Empty, string.Empty, string.Empty, string.Empty, serial.ToString() + "," + DateTime.Now.ToString(ClsGlobal.dtFormat + ".ffff") });

                    listView2.Items.Add(listitem);


                }
            }
            catch (Exception ee)
            {
                ClsFormInfo.ShowError(this, TOTA.Properties.CommResource.rsOPFail,ee);               


                return false;
            }
            return true;

        }

        private delegate bool ShowCallback(ClsScanInfo Aobj);//Handle Cross-Thread exception.

        private bool insertdata(ClsScanInfo Aobj)
        {
            try
            {
                if (this.listView2.InvokeRequired)
                {
                    object obj = (object)Aobj;
                    ShowCallback d = new ShowCallback(insertdata);
                    this.Invoke(d, new object[] { obj });

                }
                else
                {

                    if (Aobj.nOrginType < 0 || Aobj.nOrginType >10 || Aobj.nAmount == 0)
                    {
                        if (ClsGlobal.isDevelop)
                            ShowTestInfo(TOTA.Properties.Resources.rsIncompleteInfo + Aobj.cBarcode);
                        else
                            return false;
                    }

                    if (Aobj.nAmount == 1 && ClsGlobal.defaultNumber > 0 && Aobj.cBarcode.Length > ClsGlobal.defaultNumber)
                    {
                        string temps = Aobj.cBarcode.Replace("\r", "");
                        string barcode = temps.Substring(0, temps.Length - ClsGlobal.defaultNumber);
                        string num = temps.Substring(temps.Length - ClsGlobal.defaultNumber, ClsGlobal.defaultNumber);
                        // string temps = Aobj.cBarcode.Substring(Aobj.cBarcode.Length - ClsGlobal.defaultNumber, ClsGlobal.defaultNumber);
                        try
                        {
                            Aobj.nAmount = Int16.Parse(num);
                            Aobj.cBarcode = barcode;
                        }
                        catch
                        {
                            Aobj.nAmount = 1;
                        }

                    }

                    string flag=string.Empty;
                    string temp = Aobj.cRemark1;
                    bool save=true;
                    objControl.update(Aobj);
                    Aobj.cBarcode = Aobj.cBarcode.Replace("\0", "");
                    Aobj.cBatch = Aobj.cBatch.Replace("\0", "");
                    Aobj.cSelfID = Aobj.cSelfID.Replace("\0", "");
                    if (Aobj.cProductDate!=null)                    
                        Aobj.cProductDate = Aobj.cProductDate.Replace("\0", "");
                    if (Aobj.cExpireDate != null)                                        
                        Aobj.cExpireDate = Aobj.cExpireDate.Replace("\0", "");
                    if (Aobj.cMachineNo != null)
                        Aobj.cMachineNo = Aobj.cMachineNo.Replace("\0", "");
                    if (Aobj.cBill != null)
                        Aobj.cBill = Aobj.cBill.Replace("\0", "");

                    

                    if (ClsGlobal.isLocalBackup)
                    {
                        int savedb = objControl.insertScanInfo(Aobj);
                        switch (savedb)
                        {
                            case 0:
                                flag = TOTA.Properties.Resources.rsSaveLocal;// "汾رݡ";
                                save = true;
                                break;
                            case 1:
                                flag = TOTA.Properties.Resources.rsSaveRepeat;// "ظδ桡";
                                save = false;
                                break;
                            case 2:
                                flag = TOTA.Properties.Resources.rsSaveLocalFail;// "汾رʧܡ";
                                save = false;
                                break;
                        }
                        //save = objControl.insertScanInfo(Aobj);
                        //if (save)
                        //    flag = "汾رݡ";
                        //else
                        //    flag = "ظδ桡";
                    }

                    if (ClsGlobal.isInsertDB && save )
                    {
                        //if (Aobj.cScanner.Equals("N"))
                        //{

                            int savedb = objControl.insertDB(Aobj);// iSaveDB.insertData(Aobj);


                            switch (savedb)
                            {
                                case 0:
                                    flag+= TOTA.Properties.CommResource.rsSaveDBSuccess;//."浽ݿ⡡";
                                    save = true;
                                    break;                               
                                case 2:
                                    flag += TOTA.Properties.CommResource.rsSaveDBFail;//"浽ݿʧܡ";
                                    save = false;
                                    break;
                            }

                           
                        //}
                        //else
                        //{
                        //    flag += "ǹģʽ";
                        //}

                    }

                    //if (ClsGlobal.defaultCustomer.Equals(ClsGlobal.defaultCustomerZMSOFT) && (Aobj.nOrginType==0 || Aobj.nOrginType==1))//
                    //if (Aobj.cScanner.Equals("Y"))
                    if (ClsGlobal.isOutputCursorKey)
                    {
                       // clsKeyBoard.SetCharTokeyboard(Aobj.cBarcode);
                        string sendstring = string.Empty;
                        int sendcount = 1;
                        if (ClsGlobal.defaultOutputCursorKeyType == 0)
                        {
                            sendstring = Aobj.cBarcode + "," + Aobj.nAmount.ToString();
                            //clsKeyBoard.SetCharTokeyboard(Aobj.cBarcode+","+Aobj.nAmount.ToString());
                        }
                        else
                        {
                            sendstring = Aobj.cBarcode;
                            //clsKeyBoard.SetCharTokeyboard(Aobj.cBarcode);
                            sendcount = (int)Math.Ceiling(Aobj.nAmount);
                        }
                        sendstring = sendstring.Replace("\r", "");
                        sendstring = sendstring + "\r";
                        for (int i = 0; i < sendcount; i++)
                        {
                            clsKeyBoard.SetCharTokeyboard(sendstring);
                        }
                        //string sendstring = Aobj.cBarcode.Replace("\r", "");
                        //sendstring = sendstring + "\r";
                        //clsKeyBoard.SetCharTokeyboard(sendstring);

                       // flag += TOTA.Properties.Resources.rsWirelessScaner;// "ǹģʽ";
                    }

                    if (flag.Length==0)
                        flag = TOTA.Properties.Resources.rsNoProcess;// "ע,δκδ";
                    if (ClsGlobal.isDevelop)
                        flag += temp + "," + Aobj.dtReceive.ToString(ClsGlobal.dtFormat + ".ffff"); 
                    else
                        flag += Aobj.dtReceive.ToString(ClsGlobal.dtFormat + ".ffff");
                    int line = listView2.Items.Count;// +1;
                    ListViewItem listitem = null;

                    //temp = Aobj.cBarcode;
                    //if (temp.Length == 0)
                    //{
                    //    temp = Aobj.cSelfID;
                    //}

                    if (ClsGlobal.defaultCustomer.Equals(ClsGlobal.defaultCustomerZMSOFT))////&& (Aobj.nOrginType == 0 || Aobj.nOrginType == 1)
                    {
                        if (Aobj.nOrginType == 0 || Aobj.nOrginType == 1)
                            Aobj.nAmount = 1;
                       
                        listitem = new ListViewItem(new string[] { line.ToString(), Aobj.nType,Aobj.cSelfID, Aobj.cBarcode, Aobj.cBatch, Aobj.nAmount.ToString(), string.Empty, Aobj.nChannel.ToString(), Aobj.dtReceive.ToString(ClsGlobal.dtFormat + ".ffff"), string.Empty });
                    }
                    else
                        listitem = new ListViewItem(new string[] { line.ToString(), Aobj.nType, Aobj.cSelfID, Aobj.cBarcode, Aobj.cBatch, Aobj.nAmount.ToString(), Aobj.nPrice.ToString(), Aobj.nChannel.ToString(), flag, Aobj.cBill });

                    //listView2.Enabled = false;
                    //listView2.BeginUpdate();
                    listView2.Items.Add(listitem);
                    listView2.Items[listView2.Items.Count - 1].EnsureVisible();
                    listView2.Items[listView2.Items.Count - 1].Selected = true;
                    //listView2.EndUpdate();
                    //listView2.Enabled=true;


                }
            }
            catch (Exception ee)
            {
                ClsFormInfo.ShowSaveFail(this, ee);                
                
                tsbtnClose_Click(null, null);//Close
                return false;
            }
            return true;
            
        }

       
        //Event
        private void timer1_Tick(object sender, EventArgs e)//timer event for displaying current DateTime
        {
            toolStripStatusLabel1.Text = DateTime.Now.ToLocalTime().ToString();
        }
       
        
        #endregion


       
       

        private void tsbtnSystemSetup_Click(object sender, EventArgs e)
        {
                if (pFrmParameterS != null && !pFrmParameterS.IsDisposed)
                {
                    pFrmParameterS.Close();
                    pFrmParameterS = null;
                }
                pFrmParameterS = new FrmParameterSample();

                // pFrmParameter.MdiParent = this;
                pFrmParameterS.ShowDialog();
                if (pFrmParameterS.DialogResult == DialogResult.OK && ClsGlobal.defaultSkinName != pFrmParameterS.OldSkinName)
                    skinEngine1.SkinFile = ClsGlobal.defaultSkinName;
          

            
            setShowMenu();
        }

        private void tsBtnQuery_Click(object sender, EventArgs e)
        {
            
          
            
           


            
        }


        

        private void frmMain_SizeChanged(object sender, EventArgs e)
        {
            if (this.WindowState==FormWindowState.Minimized && ClsGlobal.isAutoRunOnStart)
            {
                MinimizeForm();
            } 


        }

        private void notifyIcon1_DoubleClick(object sender, EventArgs e)
        {
            this.Visible = true;

            this.WindowState = FormWindowState.Normal;

            this.notifyIcon1.Visible = false;


        }



        private void frmMain_Shown(object sender, EventArgs e)
        {
            if (ClsGlobal.isAutoRunOnStart)
            {
                MinimizeForm();
            }
              //this.WindowState = FormWindowState.Minimized;
        }

        private void notifyIcon1_MouseDoubleClick(object sender, MouseEventArgs e)
        {

        }

        private void tsBtnSetup_Click(object sender, EventArgs e)
        {
            if (ClsGlobal.defaultUsedSoftware != "default")
            {
                if (ClsGlobal.defaultUsedSoftware.Substring(0, 3).Equals("WEB"))
                {
                    //

                }
                else
                {
                    //ݿ
                    if (ClsGlobal.objDataConnect == null)
                        ClsGlobal.objDataConnect = new ClsDataConnect("connectionstring");
                }

                //FrmParameterDB pFrmParameter = new FrmParameterDB();
                Form pFrmParameter = DataAccess.CreateParameterDB();
             //   pClsFormProcess.SetupForm(pFrmParameter);
                // pFrmParameter.MdiParent = this;
                pFrmParameter.ShowDialog();
                if (pFrmParameter.DialogResult == DialogResult.OK)
                {

                }
            }
            else
            {
                //FrmParameterDB pFrmParameter = new FrmParameterDB();
                Form pFrmParameter = DataAccess.CreateParameterDB();
                // pFrmParameter.MdiParent = this;
              //  pClsFormProcess.SetupForm(pFrmParameter);
               // ClsFormProcess obj = new ClsFormProcess(pFrmParameter);
                pFrmParameter.ShowDialog();
                if (pFrmParameter.DialogResult == DialogResult.OK)
                {

                }
            }

           
             
        }

        private void frmMain_FormClosing(object sender, FormClosingEventArgs e)
        {

            DialogResult aDialogResult = ClsFormInfo.ShowConfirm(this, TOTA.Properties.CommResource.rsCloseSystem);            
            e.Cancel = aDialogResult != DialogResult.OK;
            if (e.Cancel)
                return;
            if (tsbtnClose.Enabled)            
                tsbtnClose_Click(sender, e);
        }

        private void tsmiSave_Click(object sender, EventArgs e)
        {
            string path = ClsParameterFileFormatControl.ssFileSaveDir;
            if (path.Trim().Length == 0)
                path = ClsGlobal.xmlConfigPath;
            string file = path + "\\" + DateTime.Now.ToString("yyyyMMddHHmmss") + "listview.txt";
            StreamWriter generateTxt = new StreamWriter(file, false);
            try
            {

                string temp = string.Empty;
                string linevalue = string.Empty;
                for (int i = 0; i < listView2.Columns.Count; i++) //λ
                {

                    temp = listView2.Columns[i].Text;
                    if (linevalue.Length == 0)
                        linevalue = temp;
                    else
                        linevalue += ";" + temp;

                }
                generateTxt.WriteLine(linevalue);


                
                foreach (ListViewItem item in listView2.Items)
                {
                    linevalue = string.Empty;
                    for (int i = 0; i < item.SubItems.Count; i++) //
                    {

                        temp =item.SubItems[i].Text;

                        if (linevalue.Length == 0)
                            linevalue = temp;
                        else
                            linevalue += ";" + temp;
                       
                    }
                    generateTxt.WriteLine(linevalue);
                }



            }
            catch (Exception ex)
            {
                ClsFormInfo.ShowError(this, TOTA.Properties.CommResource.rsExportFail, ex);
             
            }
            finally
            {
                generateTxt.Flush();
                generateTxt.Close();
            }
        }

        private void listView2_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        bool hasConnected = false;

        private bool AttemptConnection()
        {

            if (!hasConnected)
            {
                if (clsDownLoadIntf.AttemptConnection() != 0)
                {
                    ShowInfo(TOTA.Properties.Resources.rsOpenUSBFail);
                    return false;
                }
                ShowInfo(TOTA.Properties.Resources.rsOpenUSBSuccess);
                //  hasConnected = true;
            }
            return true;

            
        }

        private void downloadfile(string filename)
        {


           
           // Thread.Sleep(500);
            int returnflag = clsDownLoadIntf.Transferfile(filename);
            if (returnflag == 0)
                ShowInfo(TOTA.Properties.Resources.rsDownloadSuccess);
            else
                ShowInfo(TOTA.Properties.Resources.rsDownloadFail);
           
        }
       
        private void toolStripMenuItem1_Click(object sender, EventArgs e)
        {

            //DownloadGoods(true,true,true);





        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            //س
            
            string filename;
            filename = string.Empty;// @"E:\˾ļ\OBM767\OBM767\OBM767\bin\Debug\update.bin";
            if (DialogResult.OK != ofdProgram.ShowDialog())
            {
                return;
            }
            filename = ofdProgram.FileName;
            ShowInfo(TOTA.Properties.Resources.rsDownloadStart);
           // downloadfile(filename, 1);
          


            //cfilename = filename.ToCharArray(); //System.Text.Encoding.Default.GetBytes(filename);
            // char* c = cfilename;//??????

            //OBMSLABHIDDevice.clsCHIDDevice obj = new OBMSLABHIDDevice.clsCHIDDevice();
            //if (obj.AttemptConnection() != 0)
            //{
            //    ShowInfo("ʧ!");
            //    return;
            //}
            //ShowInfo("ӳɹ!");

            //cfilename = filename.ToCharArray(); //System.Text.Encoding.Default.GetBytes(filename);
            // char* c = cfilename;//??????

           // OBMSLABHIDDevice.clsCHIDDevice obj = new OBMSLABHIDDevice.clsCHIDDevice();

            unsafe
            {
                //if (!hasConnected)
                //{
                //    if (clsDownLoadIntf.AttemptConnection() != 0)
                //    {
                //        ShowInfo("ʧ!");
                //        return;
                //    }
                //    ShowInfo("ӳɹ!");
                //  //  hasConnected = true;
                //}
                if (!AttemptConnection())
                    return;
                Application.DoEvents();
                Thread.Sleep(500);
                
                if (clsDownLoadIntf.FIREDownloadCMD(filename) != 0)
                {
                    ShowInfo(TOTA.Properties.Resources.rsErrorRespond);
                    return;
                }
                Application.DoEvents();
                Thread.Sleep(500);
                downloadfile(filename);
                //ShowInfo("ʼ!");
                //Thread.Sleep(500);
                //int returnflag = clsDownLoadIntf.Transferfile(filename, "", 0);
                //if (returnflag == 0)
                //    ShowInfo("!");
                //else
                //    ShowInfo("ʧ!");
            }
        }

        private void ToolStripMenuItem3_Click(object sender, EventArgs e)
        {
            //
             //Ʒ
            string filename;
            filename = string.Empty;
            

            if (DialogResult.OK != ofdCommodity.ShowDialog())
        {
                return;
            }
            filename = ofdCommodity.FileName;
           
            ClsGoodsControl GoodsControl = new ClsGoodsControl();
            GoodsControl.DeleteGoods();
            ShowInfo(TOTA.Properties.Resources.rsImportStart);
            string temp = GoodsControl.importdata(filename);
            ShowInfo(temp);

            
        }

        private void ToolStripMenuItem4_Click(object sender, EventArgs e)
        {
           
        }

      
     

        private void ToolStripMenuItem7_Click(object sender, EventArgs e)
        {
           // openconnect();

           // DownloadGoods(false,true,true);
        }

        private void toolStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

      

        private void ApplyResource()   
        {   
            System.ComponentModel.ComponentResourceManager res = new ComponentResourceManager(typeof(frmMain));   
             
            //control   
            foreach (System.Windows.Forms.Control ctl in  Controls)   
            {   
                res.ApplyResources(ctl, ctl.Name);   
                
            }
            res.ApplyResources(ckbIsNotQuery, ckbIsNotQuery.Name);
            //ckbIsNotQuery.Text
  
            //menu   
            for(int i=0,cnt=this.menuStrip1.Items.Count;i<cnt;i++)   
            {   
                Object item = this.menuStrip1.Items[i];   
               // MessageBox.Show(item.GetType().ToString(), item.ToString());   
                if (item.GetType() == typeof(ToolStripMenuItem))    //except seperator   
                {   
                    res.ApplyResources(item, ((ToolStripMenuItem)item).Name);   
                    for (int j = 0, cnt2 = ((ToolStripMenuItem)item).DropDownItems.Count; j < cnt2; j++)   
                    {   
                        Object subitem = ((ToolStripMenuItem)item).DropDownItems[j];   
                        if (subitem.GetType() == typeof(ToolStripMenuItem))   
                        {   
                            res.ApplyResources(subitem, ((ToolStripMenuItem)subitem).Name);   
                        }   
                    }   
                }   
                   
            }   
               
              
            //toolbar   
           for (int i = 0, cnt = this.tsDownload.Items.Count; i < cnt; i++)   
            {   
                Object btn = this.tsDownload.Items[i];   
                // MessageBox.Show(item.GetType().ToString(), item.ToString());   
                if (btn.GetType() == typeof(ToolStripButton))    //except seperator   
                {   
                    res.ApplyResources(btn, ((ToolStripButton)btn).Name);   
                }

                if (btn.GetType() == typeof(ToolStripSplitButton))    //except seperator   
                {
                    res.ApplyResources(btn, ((ToolStripSplitButton)btn).Name);
                    for (int j = 0; j < ((ToolStripSplitButton)btn).DropDownItems.Count; j++)
                    {
                        ToolStripItem DropDownItem = ((ToolStripSplitButton)btn).DropDownItems[j];
                        res.ApplyResources(DropDownItem, DropDownItem.Name);
                    }
                }   
            }
            //listView
            for (int i = 0; i < listView2.Columns.Count; i++)
            {
                ColumnHeader colu = listView2.Columns[i];
                res.ApplyResources(colu, colu.Tag.ToString()); 
                
            }
              
            //Caption   
            if (languagetype==0)            
                this.Text = AssemblyTitle;
            else
                this.Text = AssemblyTrademark;
        }

        private void tsmiZHS_Click(object sender, EventArgs e)
        {
            Thread.CurrentThread.CurrentUICulture = new CultureInfo("");
            helpToolStripMenuItem.Visible = true;
            languagetype = 0;
            this.ApplyResource();
            ClsGlobal.AppCultureInfo = Thread.CurrentThread.CurrentUICulture;
            TOTA.Properties.Resources.Culture = Thread.CurrentThread.CurrentUICulture;
        }

        private void tsmiEnglish_Click(object sender, EventArgs e)
        {
            Thread.CurrentThread.CurrentUICulture = new CultureInfo("en");
            helpToolStripMenuItem.Visible = false;
            languagetype = 1;
            this.ApplyResource();
            ClsGlobal.AppCultureInfo = Thread.CurrentThread.CurrentUICulture;
            TOTA.Properties.Resources.Culture = Thread.CurrentThread.CurrentUICulture;
        }

        

        private void tsmiGoodsQuery_Click(object sender, EventArgs e)
        {
           
        }

       
        private void tsmiDownFile_Click(object sender, EventArgs e)
        {
            
           // int count = ClsRealTimeControl.ImportText(@"E:\˾ļ\OBM767\8588.csv", 0, ",");
        }

        private void tsmiUpUSBData_Click(object sender, EventArgs e)
        {
            unsafe
            {
                //if (!hasConnected)
                //{
                //    if (clsDownLoadIntf.AttemptConnection() != 0)
                //    {
                //        ShowInfo("ʧ!");
                //        return;
                //    }
                //    ShowInfo("ӳɹ!");
                //  //  hasConnected = true;
                //}
                receivetype = 2;
                if (!AttemptConnection())
                    return;
                Application.DoEvents();
                Thread.Sleep(500);
                if (clsDownLoadIntf.ItemUploadCMD() != 0)
                {
                    ShowInfo(TOTA.Properties.Resources.rsErrorRespond);
                    return;
                }

                threadrunflag = true;
                setStateMode(true);
                //toolStripStatusLabel3.Text = ""
                int receivecount = 0;
                Application.DoEvents();
                Thread.Sleep(10);
                int nBytesCount = 0;
                byte[] data = new byte[ReadLength];
                DateTime thisdate = DateTime.Now;

                while (true)
                {
                    if (receivecount > 200)
                    {
                        receivecount = 0;
                        //Thread.Sleep(10);
                        Application.DoEvents();

                    }
                    if (!threadrunflag)
                        break;
                    if (DateTime.Now.AddSeconds(-5).CompareTo(thisdate)>0)
                    {
                        //ܾûյݣΪǰ̨ϴ
                        break;
                    }
                    try
                    {
                        nBytesCount = clsDownLoadIntf.listener2(data);

                       
                    }
                    catch
                    {
                        break;
                    }
                    if (nBytesCount > 0)
                    {
                        thisdate = DateTime.Now;
                        receivedata(data, nBytesCount);
                    }
                    receivecount++;
                    //break;

                }

            }
            setStateMode(false);
            //tsbtnClose_Click(null, null);
        }

        private void tsbtnReceiveUSB_Click(object sender, EventArgs e)
        {
            // string filename;
            //filename = string.Empty;


            //if (DialogResult.OK != saveFileDialog1.ShowDialog())        
            //{
            //    return;
            //}
           
            

            //objControl.DeleteAllData();
            
            tsmiUpUSBData_Click(null,null);

            
        }

        private void tsbtnDownload_ButtonClick(object sender, EventArgs e)
        {
            tsbtnDownload.ShowDropDown();
        }

        private void tsmiDownloadBill_Click(object sender, EventArgs e)
        {
            
        }

        private void tsmitestDownload_Click(object sender, EventArgs e)
        {
            int count = clsRealTimeIntf.ImportText2(@"E:\˾ļ\OBM767\8588_2.csv", 0, ",");
            ShowInfo(count.ToString());
        }

        private void tsbtnExport_Click(object sender, EventArgs e)
        {

        }

      

       

       

        
    }
}